#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySetWord.h"
std::auto_ptr<M_ActivitySetWord> M_ActivitySetWord::msSingleton(nullptr);

int M_ActivitySetWord::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySetWordData* M_ActivitySetWord::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySetWordData>& M_ActivitySetWord::GetMapData()
{
	return mMapData;
}

void M_ActivitySetWord::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySetWord.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySetWordData data;
		data.mID = element->IntAttribute("ID");
		data.mQuantityRequired = element->IntAttribute("QuantityRequired");
		data.mNumberOfExchanges = element->IntAttribute("NumberOfExchanges");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		{
			const char* RewardCount = element->Attribute("RewardCount");
			std::vector<std::string> vecRewardCount;
			boost::split(vecRewardCount, RewardCount, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardCount.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardCount[i].c_str(), &temp))
				{
					data.mRewardCount.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySetWord Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySetWord::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySetWord");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySetWord");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySetWordData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "QuantityRequired", data.mQuantityRequired);
		LuaCfgHelper::readInt(L, "NumberOfExchanges", data.mNumberOfExchanges);
		LuaCfgHelper::readVectorInt(L, "RewardList", data.mRewardList);
		LuaCfgHelper::readVectorInt(L, "RewardCount", data.mRewardCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySetWord Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySetWord::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySetWord* M_ActivitySetWord::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySetWord());
	}
	return msSingleton.get();
}

void M_ActivitySetWord::Release()
{
	msSingleton.reset(nullptr);
}
